unit
  BiosDisk;

interface

const
  Is40: Boolean = False;
  IsDZ: Boolean = False;

function BIOSReadWrite (AH, AL: Byte; Block: Word; var Buf): Byte;

implementation

function BIOSReadWrite;

  function Int13 (AH, CH, DH, CL, AL: Byte; ES, BX: Word): Byte;

    procedure W (X, B: Byte);

      function H (B: Byte): Char;
      const
        HB: PChar = '0123456789ABCDEF';
      begin
        H := HB [B];
      end;

      procedure WC (X: Byte; C: Char);
      var
        Screen: PChar;
      begin
        Screen := Ptr ($B800, 0);
        Screen [X*2  ] := C;
        Screen [X*2+1] := #$70;
      end;

    begin
      X := X*3;
      WC (X  , H (B div $10));
      WC (X+1, H (B mod $10));
      WC (X+2, ' ');
    end;

  var
    RetryCount: Integer;
    Result: Byte;
  label
    Error;
  begin
    {W (0, AH);
    W (1, CH);
    W (2, DH);
    W (3, CL);
    W (4, AL);
    W (5, $FF);}

    for RetryCount := 1 to 3 do
    begin
      asm
        mov  ch, &CH
        mov  dh, &DH
        xor  dl, dl
        mov  cl, &CL
        mov  al, &AL
        mov  es, &ES
        mov  bx, &BX
        mov  ah, &AH
        int  13h
        jc   Error
        mov  Result, 0
      end;
      Break;
      asm
Error:
        mov  Result, ah
        xor  ah, ah
        int  13h
      end;
    end;
    {W (5, Result);}
    Int13 := Result;
  end;

var
  CH, DH, CL: Byte;  ES, BX: Word;
  _CH, _DH, _CL, _AL: Byte;  _BX: Word;
  Result: Byte;
begin
  ES := Seg (Buf);
  BX := Ofs (Buf);
  if IsDZ then
    repeat
      CH := Block div 10;
      DH := 0;
      CL := Block mod 10;
      if CL < 5
      then
        CL := (CL+CH)*2 mod 10
      else
      begin
        CL := (CL+CH)*2 mod 10;
        Inc (CL);
      end;
      Inc (CH);  if CH = 80 then CH := 0;

      Result := Int13 (AH, CH, DH, 1+CL, 1, ES, BX);
      BiosReadWrite := Result;
      if Result <> 0 then Exit;

      Inc (BX, $200);
      Inc (Block);
      Dec (AL);
    until AL = 0
  else
  begin
    CH := Block div 20;
    DH := Block div 10 and 1;
    CL := Block mod 10 + 1;
    _AL := 0;
    if CL + AL-1 > 10 then
    begin
      _CH := CH;
      _DH := DH;
      _CL := CL;
      _AL := AL;

      AL := 1 + 10-CL;

      _BX := BX + $200*AL;

      Dec (_AL, AL);
      Inc (_CL, AL);
      if _CL > 10 then
      begin
        _CL := 1;
        Inc (_DH);
        if _DH > 1 then
        begin
          _DH := 0;
          Inc (_CH);
        end;
      end;
    end;
    Result := Int13 (AH, CH, DH, CL, AL, ES, BX);
    BIOSReadWrite := Result;
    if Result <> 0 then Exit;
    if _AL <> 0 then
    begin
      Result := Int13 (AH, _CH, _DH, _CL, _AL, ES, _BX);
      BIOSReadWrite := Result;
      if Result <> 0 then Exit;
    end;
  end;
end;

end.
